/*********************************************************************
   DSCLASS.CH

    This Clipper header-file is a part of the Clip_Oop()
    function to  define and to manipulate psuedo objects
    << Danny Sukdeo (c) 1991 for Danny's Solveware >>
*********************************************************************/

#define OOP_CREATE_CLASS         1
#define OOP_CREATE_INSTVAR       2 
#define OOP_CREATE_METHOD        3
#define OOP_INHERIT_CLASS        4
#define OOP_END_CLASS            5
#define OOP_GET_INSTVAR          6
#define OOP_SET_INSTVAR          7
#define OOP_DO_METHOD            8
#define OOP_CREATE_NEW_OBJECT    9
#define OOP_ACTIVE_OBJECT        10

#define OOP_INSTVAR_TYPE            1
#define OOP_METHOD_TYPE             2

#define ERR_CLASS_EXISTS            1
#define ERR_CLASS_NOT_FOUND_MSG     2
#define ERR_INSTANCE_NOT_FOUND      3
#define ERR_NOT_AN_INSTANCE         4
#define ERR_NOT_ASSIGNABLE          5
#define ERR_NOT_A_METHOD            6
#define ERR_NO_ACTIVE_OBJECT        7
#define ERR_CANNOT_INHERIT          8
#define ERR_CLASS_NOT_FOUND_OBJECT  9


#translate FSend(<obj>:<msg>) => ;
   Clip_Oops( OOP_GET_INSTVAR, <obj>, #<msg> )
#translate FSend(<obj>:<msg>([<arg,...>]) ) => ;
   Clip_Oops( OOP_DO_METHOD, <obj>, #<msg>, NIL [, <arg>] )
#translate ActiveObject() => ;
   Clip_Oops( OOP_ACTIVE_OBJECT )
#command SEND <obj>:<msg> => ;
   Clip_Oops( OOP_DO_METHOD, <obj>, #<msg> )
#command SEND <obj>:<msg>([<arg,...>]) => ;
   Clip_Oops( OOP_DO_METHOD, <obj>, #<msg>, NIL [, <arg>] )
#command SEND <obj>:<msg> := <arg> => ;
   Clip_Oops( OOP_SET_INSTVAR, <obj>, #<msg>, <arg> )
#command SEND <obj>:<msg> = <arg> => ;
   Clip_Oops( OOP_SET_INSTVAR, <obj>, #<msg>, <arg> )
#command SEND <obj>:<msg> TO <x> => ;
   <x> := Clip_Oops( OOP_GET_INSTVAR, <obj>, #<msg> )
#command CLASS: <obj> => ;
   Clip_Oops( OOP_CREATE_CLASS, <(obj)> )
#command INSTANCE VAR: <msg> = <arg> => ;
   Clip_Oops( OOP_CREATE_INSTVAR, NIL, <(msg)>, <arg> )
#command INSTANCE VAR: <msg> := <arg> => ;
   Clip_Oops( OOP_CREATE_INSTVAR, NIL, <(msg)>, <arg> )
#command METHOD: <msg>([<arg,...>]) => ;
   Clip_Oops( OOP_CREATE_METHOD, NIL, #<msg>, ;
   { |[<arg>]| <msg>([<arg>])} )
#command INHERIT: <obj> => ;
   Clip_Oops( OOP_INHERIT_CLASS, <(obj)> )
#command ENDCLASS [: <*x*> ] => ;
   Clip_Oops( OOP_END_CLASS )
#command CREATE OBJECT <sub> FROM <obj>  => ;
   <sub> := ;
   ACLONE( Clip_Oops( OOP_CREATE_NEW_OBJECT, <(obj)> ) )

// EOF: Dsclass.ch

